javax.jms

## Interface CompletionListener

-     public interface CompletionListener

  A `CompletionListener` is implemented by the application and may be specified when a message is sent asynchronously.

  When the sending of the message is complete, the JMS provider notifies the application by calling the `onCompletion(Message)` method of the specified completion listener. If the sending if the message fails for any reason, and an exception cannot be thrown by the `send` method, then the JMS provider calls the `onException(Exception)` method of the specified completion listener.

  Since:
    JMS 2.0
  See Also:
    `MessageProducer.send(javax.jms.Message,int,int,long,javax.jms.CompletionListener)`, `MessageProducer.send(javax.jms.Destination,javax.jms.Message,javax.jms.CompletionListener)`, `MessageProducer.send(javax.jms.Destination,javax.jms.Message,int,int,long,javax.jms.CompletionListener)`, `JMSProducer.setAsync(javax.jms.CompletionListener)`, `JMSProducer.getAsync()`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `onCompletion(Message message)` Notifies the application that the message has been successfully sent
    `void` | `onException(Message message, Exception exception)` Notifies user that the specified exception was thrown while attempting to send the specified message.

- - ### Method Detail

    - #### onCompletion

          void onCompletion(Message message)

      Notifies the application that the message has been successfully sent
      Parameters:
        `message` - the message that was sent.

    - #### onException

          void onException(Message message,
                         Exception exception)

      Notifies user that the specified exception was thrown while attempting to send the specified message. If an exception occurs it is undefined whether or not the message was successfully sent.
      Parameters:
        `message` - the message that was sent.
        `exception` - the exception

Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.